// New Room
// チャットルーム生成ボタン処理
$("#createChatRoom").on("click", function () {
  //loadingIndicatorを表示
  CHAT_UI.showLoadingIndicator();

  let isInvite = false;
  CHAT.globalIsInvite = isInvite;
  socket.emit("getGroupList", isInvite);
});

//メッセージ送信
$("#messageInput").on("keypress", function (event) {
  if (event.which == 13) {
    // Enterキーの処理
    $("#messageSend").click();
  }
});

// 写真アップロード
$("#imageInputButton").on("click", function () {
  $("#imageInputTag").click();
});

// 動画アップロード
$("#videoUploadButton").on("click", function () {
  $("#videoInputTag").click();
});

$("#imageInputTag").on("change", function () {
  $("#image-form").submit();
  // reset the value of form
  $("#imageInputTag").val("");
});

$("#videoInputTag").on("change", function () {
  $("#video-form").submit();
  // reset the value of form
  $("#videoInputTag").val("");
});

$("#image-form").on("submit", function (e) {
  e.preventDefault();
  const imageInputTag = $("#imageInputTag");
  const file = imageInputTag.prop("files")[0];
  if (file) {
    $(".overlay").addClass("active undismissable");
    $(".loader").addClass("active");
    CHAT_UI.showLoadingIndicator();
    var fd = new FormData($(this)[0]);
    console.log($(this)[0]);
    //画像の大きさが500pixelより大きかったら、thumbnailを生成
    CHAT.createThumbnailAndUpload(
      file,
      function (resizeFile, thumbnailCreated) {
        if (resizeFile && thumbnailCreated) {
          //ただ、画像の大きさが500pixel以下の場合はthumbnailは生成されない
          fd.append("thumb", resizeFile);
        }

        // イメージをアップロード
        CHAT.uploadImage(fd);
      }
    );
  }
});

$("#video-form").on("submit", function (e) {
  e.preventDefault();
  const videoInputTag = $("#videoInputTag");
  const file = videoInputTag.prop("files")[0];
  if (file) {
    $(".overlay").addClass("active undismissable");
    $(".loader").addClass("active");
    CHAT_UI.showLoadingIndicator();
    var fd = new FormData($(this)[0]);

    if (!file.type.includes("image")) {
      // video 保存
      // CHAT.createVideoThumbnailAndUpload(file, function(resizeFile, thumbnailCreated) {
      //     if(resizeFile && thumbnailCreated) {
      //         //ただ、画像の大きさが500pixel以下の場合はthumbnailは生成されない
      //         fd.append('thumb', resizeFile)
      //     }
      //     CHAT.uploadImage(fd);
      // })
      CHAT.uploadImage(fd);
      return;
    }
  }
});

$("#tabDM").on("click", function (e) {
  CHAT_UI.refreshRoomList(ChatRoomType.DM);
});

$("#tabGroup").on("click", function (e) {
  CHAT_UI.refreshRoomList(ChatRoomType.GROUP);
});

$("#tabAllGroup").on("click", function (e) {
  CHAT_UI.refreshAllGroupSearch("0");
});

$("#tabMyGroup").on("click", function (e) {
  $("#contactSearch").attr("placeholder", getLocalizedString("userSearch"));
  CHAT_UI.refreshContactScreen();
});

$("#tabMyGroupOnMakeRoom").on("click", function (e) {
  CHAT_UI.refreshMyGroupForMakeRoom();
});

$("#tabAllGroupOnMakeRoom").on("click", function (e) {
  CHAT_UI.refreshAllGroupForMakeRoom("0");
});

$("#tabMyGroupOnAddUser").on("click", function (e) {
  CHAT_UI.refreshMyGroupForAddUser();
});

$("#tabAllGroupOnAddUser").on("click", function (e) {
  CHAT_UI.refreshAllGroupForAddUser("0");
});

$("#tabMyGroupOnAddUserInCollaboration").on("click", function (e) {
  CHAT_UI.refreshMyGroupForAddUserInCollaboration();
});

$("#tabAllGroupOnAddUserInCollaboration").on("click", function (e) {
  CHAT_UI.refreshAllGroupForAddUserInCollaboration("0");
});

$("#makeRoomConfirmBtn").on("click", function (e) {
  const selectedUserList = CHAT.globalSelectedUserList.join(",");
  NativeBridgeDelegate.saveSelectedUserList(selectedUserList);
  $("#makeRoomForm").submit();
});

$("#addUserConfirmBtn").on("click", function (e) {
  const selectedUserList = CHAT.globalSelectedUserList.join(",");
  NativeBridgeDelegate.saveSelectedUserList(selectedUserList);
  $("#addUserForm").submit();
});
